//+------------------------------------------------------------------+
//|                                      MACDBars.mq4 modified from  |
//|                                              mtt-ErgodicMACD.mq4 |
//|                   Copyright  2004-07, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2004-07, mietectec"
#property  link      ""
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color1  Green
#property  indicator_color2  Red
#property indicator_width1 4
#property indicator_width2 4
#property  indicator_minimum 0
#property  indicator_maximum 1

// MACD

extern string TimeFrame  = "Current time frame";
extern int    FastEma    = 12;
extern int    SlowEma    = 26;
extern int    SignalSMMA = 9;
extern int    PriceField = PRICE_CLOSE;

double ExtMapBuffer1[];
double ExtMapBuffer2[];
bool   returnBars;
int    timeFrame;
string indicatorFileName;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   SetIndexBuffer(0,ExtMapBuffer1); SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,4,indicator_color1); SetIndexLabel(0,"BuyZone");
   SetIndexBuffer(1,ExtMapBuffer2); SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,4,indicator_color2); SetIndexLabel(1,"SellZone");

      timeFrame  = stringToTimeFrame(TimeFrame);
      returnBars = (TimeFrame=="returnBars");
      indicatorFileName = WindowExpertName();

   IndicatorShortName(timeFrameToString(timeFrame) + " MACD ("+FastEma+","+SlowEma+","+SignalSMMA+")");   
   return(0);
}
int deinit() { return(0);}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
           int limit = MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { ExtMapBuffer1[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   for (int i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
        double indMacdMain0   = iMACD(NULL,timeFrame,FastEma, SlowEma, SignalSMMA,PriceField,0,y);
        double indMacdSignal0 = iMACD(NULL,timeFrame,FastEma, SlowEma, SignalSMMA,PriceField,1,y);
         ExtMapBuffer1[i] = EMPTY_VALUE;
         ExtMapBuffer2[i] = EMPTY_VALUE;
            if (indMacdMain0 >= indMacdSignal0) ExtMapBuffer1[i] = 1;
            if (indMacdMain0 < indMacdSignal0 ) ExtMapBuffer2[i] = 1;
   }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}